{% from "packages/components/tables/macro.njk" import table %}
{#
  This macro generates a structured list of medications or products, it dynamically adds rows to medication list table and corresponds to search link.
  
  params: 
  products: contains productList, column-name and description for empty product list - object { productList: [object { productInitialLetter: text, rows: "" or [object {productName: text, drugName: text]}], emptyProductListDescription: text, productTableColumnNames: object {columnNameOne: text, columnNameTwo: text}}
  content: object { paragraph1: text, paragraph2: text, paragraph3: text, paragraph4: text }
#}
{% macro hrtMedicationList(products, content) %}
  <p>{{ content.paragraph1 }}</p>
  <p>{{ content.paragraph2 }}</p>
  <p>{{ content.paragraph3 }}</p>
  <p>{{ content.paragraph4 }}</p>

  <nav class="nhsuk-u-margin-bottom-4 nhsuk-u-margin-top-4" id="nhsuk-nav-a-z" role="navigation" aria-label="A to Z Navigation">
    {# Generate navigation links for each product category. #}
    <ol class="nhsuk-list nhsuk-u-clear nhsuk-u-margin-0" role="list">
    {% for rowData in products.productList %}
        {% set rowLink = " <li class='nhsuk-u-margin-bottom-0 nhsuk-u-float-left nhsuk-u-margin-right-1'><a class='nhsuk-u-font-size-22 nhsuk-u-padding-2 nhsuk-u-display-block' id=nhsuk-search-medicine-"+ rowData.productInitialLetter +" href=#"+ rowData.productInitialLetter +"> "+ rowData.productInitialLetter +"</a></li>"%}
        {{rowLink|safe}}
    {% endfor %}   
    </ol>
  </nav>

  {% for rowData in products.productList %}
    {% if (rowData.rows) !== "" %}
    {# Construct product table rows for each category for non-empty productList rows #}
      {% set productTableRows = [] %}
      {% for rowProductData in rowData.rows %}
        {% set row = [
          {
            html: "<span tabIndex=0>" + rowProductData.productName + "</span>"
          },
          {
            html: "<span tabIndex=0>" + rowProductData.drugName + "</span>"
          }
         ]
      %}
        {% set safeRowsLength = productTableRows.push(row) %}
      {% endfor %} 

      <div class="nhsuk-do-dont-list">
        <h2 class="nhsuk-do-dont-list__label" id="{{rowData.productInitialLetter}}" tabIndex=0> {{rowData.productInitialLetter}}</h2>
        {# Create a table for displaying product information. #}
        {{ table({
          panel: false,
          firstCellIsHeader: false,
          head: [{html: "<span tabIndex=0>" + products.productTableColumnNames.columnNameOne + "</span>"}, {html: "<span tabIndex=0>" + products.productTableColumnNames.columnNameTwo + "</span>"}],
          rows:  productTableRows
        }) }}
      </div> 
    {% else %} 
      <div class="nhsuk-do-dont-list">
        <h2 class="nhsuk-do-dont-list__label" id="{{rowData.productInitialLetter}}" tabIndex=0 >{{rowData.productInitialLetter}}</h2>
        {# Display a message for empty product categories. #}
        <ul class="nhsuk-list nhsuk-list--border">
          <li tabIndex="0" >{{ products.emptyProductListDescription }}</li>
        </ul>
      </div>
     {% endif %}
  {% endfor %}   
{% endmacro %}